/*## (c) SECURITY EXPLORATIONS    2018 Poland                                #*/
/*##     http://www.security-explorations.com                                #*/
/*## (c) AG Security Research     2019-2022 Poland                           #*/
/*##     http://www.agsecurityresearch.com                                   #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

package mod.mspr;

import agsecres.tool.*;
import java.lang.*;

public class ProgressPrinter {
 public static final int MARK_CNT     = 32;

 String hdr;
 int len;
 int maxval;

 int printed;

 public ProgressPrinter(String hdr,int len,int maxval) {
  this.hdr=hdr;
  this.len=len;
  this.maxval=maxval;

  reset();
 }

 public ProgressPrinter(String hdr,int maxval) {
  this(hdr,MARK_CNT,maxval);
 }

 public ProgressPrinter(int maxval) {
  this(null,MARK_CNT,maxval);
 }

 public void reset() {
  printed=0;
 }

 private void print_mark(int cnt) {
  for(int i=0;i<cnt;i++) {
   Shell.print("#");
  }
 }

 public void update(int val) {
  if (printed==0) {
   if (hdr!=null) Shell.println(hdr);
   Shell.print("[");
   printed++;
  }

  int cnt=(val*len)/maxval;

  if (printed<cnt) {
   print_mark(cnt-printed);
   printed=cnt;
  }

  if ((cnt==len)&&(printed<=cnt)) {
   Shell.println("]");
   printed++;
  }
 }
}
